#include <windows.h>

void SetTextToClipboard(LPCSTR pszText)
{
    LPTSTR   lpszPtr;
    HGLOBAL  hMem;

    if (pszText == NULL)
        return;
    if (!OpenClipboard(NULL))
        return;
    hMem = GlobalAlloc(GHND,strlen(pszText) + 1);
    lpszPtr = (LPTSTR)GlobalLock(hMem);
    strcpy(lpszPtr,pszText);
    GlobalUnlock(hMem);
    EmptyClipboard();

    if (SetClipboardData(CF_TEXT,hMem) == NULL)
        GlobalFree(hMem);
    CloseClipboard();
    return;
}

void __cdecl WinMainCRTStartup( void )
{
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    SECURITY_ATTRIBUTES sa;
    char calcCmd[8192];
    char calcScript[8192];
    char *argv;
    char *calc_s;
    HANDLE hReadPipe = NULL, hWritePipe = NULL, hErrReadPipe = NULL, hErrWritePipe = NULL;

    argv = GetCommandLine();
    calc_s = calcScript;
    while(*argv){
        if (*argv == ' '){
            argv++;
            while(*argv){
                if (*argv > ' ')
                    *calc_s++ = *argv++;
                else
                    argv++;
            }
        }
        else
            argv++;
    }
    if(strlen(calcScript) < 1)
            ExitProcess(0);
        
    wsprintf(calcCmd, "%s %s", "calc.exe", calcScript);

    sa.nLength = sizeof(SECURITY_ATTRIBUTES);
    sa.lpSecurityDescriptor = NULL;
    sa.bInheritHandle = TRUE;

    CreatePipe(&hReadPipe, &hWritePipe, &sa, 8192);
    CreatePipe(&hErrReadPipe, &hErrWritePipe, &sa, 8192);

    ZeroMemory((LPVOID)&si, sizeof(STARTUPINFO));
    si.cb          = sizeof(STARTUPINFO);
    si.dwFlags     = STARTF_USESTDHANDLES;
    si.wShowWindow = SW_HIDE;
    si.hStdOutput = hWritePipe;
    si.hStdError  = hErrWritePipe;

    if (CreateProcess(NULL, calcCmd, NULL, NULL, TRUE, DETACHED_PROCESS, NULL, NULL, &si, &pi))
    {
        char bufStdOut[8192], bufErrOut[8192], msg[8192];
        DWORD dwStdOut = 0, dwErrOut = 0;
        DWORD dwRet;
        DWORD res;
        LPTSTR p;
        int flg;

        while ( (dwRet = WaitForSingleObject(pi.hProcess, 0)) != WAIT_ABANDONED)
        {
            MSG msg;

            PeekNamedPipe(hReadPipe, NULL, 0, NULL, &dwStdOut, NULL);
            if (dwStdOut > 0)
                ReadFile(hReadPipe, bufStdOut, sizeof(bufStdOut) - 1, &dwStdOut, NULL);
            PeekNamedPipe(hErrReadPipe, NULL, 0, NULL, &dwErrOut, NULL);
            if (dwErrOut > 0)
                ReadFile(hErrReadPipe, bufErrOut, sizeof(bufErrOut) - 1, &dwErrOut, NULL);
            if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            if (dwRet == WAIT_OBJECT_0)
                break;
        }
        GetExitCodeProcess(pi.hProcess, &res);
        CloseHandle(pi.hProcess);
        CloseHandle(pi.hThread);
        p = strchr(bufStdOut, '\r');
        if ( p != NULL )
            *p = '\0';
        wsprintf(msg, "%s=  %s", calcScript, bufStdOut+1);
        flg = MessageBox(NULL, msg, "copy answer to clipboard?", MB_YESNO|MB_DEFBUTTON2);
        if ( flg == IDYES )
            SetTextToClipboard(bufStdOut+1);
    }
    
    CloseHandle(hWritePipe);
    CloseHandle(hReadPipe);
    CloseHandle(hErrWritePipe);
    CloseHandle(hErrReadPipe);
    ExitProcess(0);
}
